Unit QSL3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSL3R(var RINT :Real; var A :Real; var B :Real; F :Func_F1;
                E :Real; var XA :Real);

implementation

procedure QSL3R(var RINT :Real; var A :Real; var B :Real; F :Func_F1;
                E :Real; var XA :Real);
var
N,IL,O :Integer;
INT,INT2,I,J,K,L,M,C,W,E1,Z2,H,Z1,EPS,P,H0,Q,R :Real;
NI :Boolean;
AY :Array [0..6] of Real;
BY :Array [0..6] of Real;
KSI :Array [0..6] of Real;
OM :Array [0..2] of Integer;
D :Array [0..2] of Real;
const
SYS051 :Real = 1.192093E-7;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28;
begin
{   DATA  FORTRAN  }
AY[0] := 0.02380952;
AY[1] := 0.2438095;
AY[2] := 0.02380952;
AY[3] := 0.1384130;
AY[4] := 0.2158727;
AY[5] := 0.2158727;
AY[6] := 0.1384130;
BY[0] := -0.07619047;
BY[1] := 0.2438095;
BY[2] := -0.07619047;
BY[3] := 0.1837020;
BY[4] := -0.2294162;
BY[5] := -0.2294162;
BY[6] := 0.1837020;
KSI[0] := 0.0;
KSI[1] := 0.5;
KSI[2] := 1.0;
KSI[3] := 0.08488805;
KSI[4] := 0.2655756;
KSI[5] := 0.7344244;
KSI[6] := 0.9151119;
EPS := E;
IL := 1;
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _2;
INT := 0.0;
E1 := 0.0;
goto _28;
_2:
Z2 := E/W;
H := 1.0;
N := 0;
Z1 := EPS/W;
_3:
P := 0.0;
E1 := 0.0;
INT := 0.0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_4:
K := P+H;
L := 0.0;
M := 0.0;
for O:=1 to 3 do
 begin
  if ( OM[O-1]  = 0 ) 
   then goto _5;
  I := D[O-1];
  goto _6;
_5:
  J := H*KSI[O-1]+P;
  D[O-1] := F(W*J+A);
  I := D[O-1];
  OM[O-1] := 1;
_6:
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_7:
 end;
for O:=4 to 7 do
 begin
  J := H*KSI[O-1]+P;
  I := F(W*J+A);
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_8:
 end;
L := H*L;
M := Abs(H*M);
if ( M-Z1 ) < 0
 then goto _9
 else if ( M-Z1 ) > 0
       then goto _18
       else goto _18;
_9:
P := K;
E1 := E1+M;
INT := INT+L;
I := 1-P;
N := N+1;
if ( N-1 ) < 0
 then goto _11
 else if ( N-1 ) > 0
       then goto _11
       else goto _10;
_10:
H0 := H;
_11:
if ( 1.0+I/64-1.0 ) < 0
 then goto _12
 else if ( 1.0+I/64-1.0 ) > 0
       then goto _14
       else goto _12;
_12:
J := Abs(F(B))+Abs(D[2]);
J := J*I;
if ( J-Z2 ) < 0
 then goto _22
 else if ( J-Z2 ) > 0
       then goto _13
       else goto _22;
_13:
XA := A+P*W;
INT := INT*W;
_QSCOMX.elm1 := XA;
UTQS11(N,4);
goto _28;
_14:
D[0] := D[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( M-Z1/IntPower(2.0,7) ) < 0
 then goto _15
 else if ( M-Z1/IntPower(2.0,7) ) > 0
       then goto _16
       else goto _16;
_15:
H := 2.0*H;
_16:
if ( H-I ) < 0
 then goto _4
 else if ( H-I ) > 0
       then goto _17
       else goto _4;
_17:
H := I;
goto _4;
_18:
H := H/2.0;
if ( H-SYS051*P ) < 0
 then goto _19
 else if ( H-SYS051*P ) > 0
       then goto _21
       else goto _19;
_19:
if ( P ) < 0
 then goto _20
 else if ( P ) > 0
       then goto _13
       else goto _20;
_20:
if ( H/4.0 ) < 0
 then goto _13
 else if ( H/4.0 ) > 0
       then goto _21
       else goto _13;
_21:
D[2] := D[1];
OM[1] := 0;
goto _4;
_22:
Q := Z2*(1.0+Abs(INT));
if ( E1-Q ) < 0
 then goto _27
 else if ( E1-Q ) > 0
       then goto _23
       else goto _27;
_23:
if ( IL-1 ) < 0
 then goto _24
 else if ( IL-1 ) > 0
       then goto _24
       else goto _25;
_24:
R := Abs(INT-INT2);
if ( R-Q ) < 0
 then goto _26
 else if ( R-Q ) > 0
       then goto _25
       else goto _26;
_25:
INT2 := INT;
IL := 2;
EPS := EPS/IntPower(2.0,7);
H := H0;
goto _3;
_26:
E1 := R;
_27:
INT := INT*W;
XA := B;
if (  not ( (NI) ) ) 
 then goto _28;
C := B;
B := A;
A := C;
INT := -INT;
_28:
RINT := INT;
end;

end.
